<?php declare(strict_types=1);

namespace Paycoiner\Client\Models\Webhooks;

use Paycoiner\Client\Models\Model;

class DepositReceived extends Model
{
    protected $depositId;
    protected $customerId;
    protected $txId;
    protected $address;
    protected $amount;
    protected $currency;
    protected $confirmations = 0;
    protected $finalConfirmed = false;
    protected $rejected = false;
    /** @var int|null */
    protected $blockHeight;

    public function __construct(
        string $depositId,
        string $customerId,
        string $txId,
        string $address,
        string $amount,
        string $currency,
        int $confirmations = 0,
        bool $finalConfirmed = false,
        int $blockHeight = null,
        bool $rejected = false
    ) {
        $this->depositId = $depositId;
        $this->customerId = $customerId;
        $this->txId = $txId;
        $this->address = $address;
        $this->amount = $amount;
        $this->currency = $currency;
        $this->confirmations = $confirmations;
        $this->finalConfirmed = $finalConfirmed;
        $this->blockHeight = $blockHeight;
        $this->rejected = $rejected;
    }

    /**
     * Unique deposit identifier generated by Paycoiner
     */
    public function getDepositId(): string
    {
        return $this->depositId;
    }

    /**
     * Customer identifier
     */
    public function getCustomerId(): string
    {
        return $this->customerId;
    }

    /**
     * The Transaction Id in blockchain
     */
    public function getTxId(): string
    {
        return $this->txId;
    }

    /**
     * On which address has come the deposit
     */
    public function getAddress(): string
    {
        return $this->address;
    }

    /**
     * Exactly received amount
     */
    public function getAmount(): string
    {
        return $this->amount;
    }

    /**
     * Uppercase currency code.
     * @example BTC
     */
    public function getCurrency(): string
    {
        return $this->currency;
    }

    /**
     * Total transaction confirmations count.
     */
    public function getConfirmations(): int
    {
        return $this->confirmations;
    }

    /**
     * Is true when Paycoiner decided that confirmations count greater than expected confirmations count for finally confirmation.
     * Please check this attribute before book deposit.
     */
    public function isFinalConfirmed(): bool
    {
        return $this->finalConfirmed;
    }

    /**
     * @return int|null
     */
    public function getBlockHeight()
    {
        return $this->blockHeight;
    }

    /**
     * Is true when the transaction disappeared from the blockchain
     */
    public function isRejected(): bool
    {
        return $this->rejected;
    }
}
